=== modified file 'DBUS-API'
--- DBUS-API	2014-08-10 14:13:02 +0000
+++ DBUS-API	2012-01-15 20:27:28 +0000
@@ -150,6 +150,9 @@
     milliseconds, depending on ApprovedByDefault.  Approve() can now
     usefully be called on this client object.
     
+*** PropertyChanged(s: Property, v: Value)
+    The Property on this client has changed to Value.
+    
 *** Rejected(s: Reason)
     This client was not given its secret for a specified Reason.
 

=== modified file 'Makefile'
--- Makefile	2015-06-28 16:35:27 +0000
+++ Makefile	2014-07-17 03:24:57 +0000
@@ -26,7 +26,7 @@
 OPTIMIZE=-Os -fno-strict-aliasing
 LANGUAGE=-std=gnu99
 htmldir=man
-version=1.6.9
+version=1.6.7
 SED=sed
 
 USER=$(firstword $(subst :, ,$(shell getent passwd _mandos || getent passwd nobody || echo 65534)))
@@ -106,8 +106,7 @@
 PLUGINS=plugins.d/password-prompt plugins.d/mandos-client \
 	plugins.d/usplash plugins.d/splashy plugins.d/askpass-fifo \
 	plugins.d/plymouth
-PLUGIN_HELPERS=
-CPROGS=plugin-runner $(PLUGINS) $(PLUGIN_HELPERS)
+CPROGS=plugin-runner $(PLUGINS)
 PROGS=mandos mandos-keygen mandos-ctl mandos-monitor $(CPROGS)
 DOCS=mandos.8 mandos-keygen.8 mandos-monitor.8 mandos-ctl.8 \
 	mandos.conf.5 mandos-clients.conf.5 plugin-runner.8mandos \
@@ -274,7 +273,6 @@
 	@echo "###################################################################"
 # We set GNOME_KEYRING_CONTROL to block pam_gnome_keyring
 	./plugin-runner --plugin-dir=plugins.d \
-		--plugin-helper-dir=plugin-helpers \
 		--config-file=plugin-runner.conf \
 		--options-for=mandos-client:--seckey=keydir/seckey.txt,--pubkey=keydir/pubkey.txt,--network-hook-dir=network-hooks.d \
 		--env-for=mandos-client:GNOME_KEYRING_CONTROL= \
@@ -358,7 +356,6 @@
 	if [ "$(CONFDIR)" != "$(LIBDIR)/mandos" ]; then \
 		install --mode=u=rwx \
 			--directory "$(CONFDIR)/plugins.d"; \
-		install --directory "$(CONFDIR)/plugin-helpers"; \
 	fi
 	install --mode=u=rwx,go=rx --directory \
 		"$(CONFDIR)/network-hooks.d"

=== modified file 'NEWS'
--- NEWS	2014-10-05 20:08:58 +0000
+++ NEWS	2014-07-17 03:24:57 +0000
@@ -1,18 +1,6 @@
 This NEWS file records noteworthy changes, very tersely.
 See the manual for detailed information.
 
-Version 1.6.9 (2014-10-05)
-* Server
-** Changed to emit standard D-Bus signal when D-Bus properties change.
-   (The old signal is still emitted too, but marked as deprecated.)
-
-Version 1.6.8 (2014-08-06)
-* Client
-** Bug fix: mandos-keygen now generates working SSH checker commands.
-* Server
-** Bug fix: "mandos-monitor" now really redraws screen on Ctrl-L.
-** Now requires Python 2.7.
-
 Version 1.6.7 (2014-07-17)
 * Client
 ** Bug fix: Now compatible with GPGME 1.5.0.

=== modified file 'TODO'
--- TODO	2014-10-05 19:39:25 +0000
+++ TODO	2014-07-14 21:41:08 +0000
@@ -23,7 +23,6 @@
 ** TODO [#B] Use capabilities instead of seteuid().
 ** TODO [#B] Use getaddrinfo(hints=AI_NUMERICHOST) instead of inet_pton()
 ** TODO [#C] Make start_mandos_communication() take "struct server".
-** TODO [#C] --interfaces=regex,eth*,noregex (bridge-utils-interfaces(5))
 
 * splashy
 ** TODO [#B] use scandir(3) instead of readdir(3)
@@ -33,6 +32,7 @@
 ** TODO [#B] use scandir(3) instead of readdir(3)
 
 * askpass-fifo
+** TODO [#B] Drop privileges after opening FIFO.
 
 * password-prompt
 ** TODO [#B] lock stdin (with flock()?)
@@ -48,9 +48,6 @@
 ** kernel command line option for debug info
 
 * mandos (server)
-** TODO [#B] Work around Avahi issue
-   Avahi does not announce link-local addresses if any global
-   addresses exist: http://lists.freedesktop.org/archives/avahi/2010-March/001863.html
 ** TODO [#B] Log level							  :BUGS:
 *** TODO /etc/mandos/clients.d/*.conf
     Watch this directory and add/remove/update clients?
@@ -72,6 +69,9 @@
 ** TODO Use python-tlslite?
 ** TODO D-Bus AddClient() method on server object
 ** TODO Use org.freedesktop.DBus.Method.NoReply annotation on async methods. :2:
+** TODO Emit [[http://dbus.freedesktop.org/doc/dbus-specification.html#standard-interfaces-properties][org.freedesktop.DBus.Properties.PropertiesChanged]] signal	  :2:
+   TODO Deprecate se.recompile.Mandos.Client.PropertyChanged - annotate!
+   TODO Can use "invalidates" annotation to also emit on changed secret.
 ** TODO Support [[http://dbus.freedesktop.org/doc/dbus-specification.html#standard-interfaces-objectmanager][org.freedesktop.DBus.ObjectManager]] interface on server object :2:
    Deprecate methods GetAllClients(), GetAllClientsWithProperties()
    and signals ClientAdded and ClientRemoved.
@@ -80,13 +80,12 @@
 ** TODO Secret Service API?
    http://standards.freedesktop.org/secret-service/
 ** TODO Remove D-Bus interfaces with old domain name			  :2:
-** TODO Remove old string_to_delta format				     :2:
+** TODO Remove old string_to_delta format				  :2:
 ** TODO http://0pointer.de/blog/projects/stateless.html
 *** tmpfiles snippet to create /var/lib/mandos with right user+perms
 *** File in /usr/lib/sysusers.d to create user+group "_mandos"
 ** TODO Error handling on error parsing config files
 ** TODO init.d script error handling
-** TODO D-Bus server properties; address, port, interface, etc.		     :2:
 
 * mandos.xml
 ** Add mandos contact info in manual pages
@@ -94,7 +93,7 @@
 * mandos-ctl
 *** Handle "no D-Bus server" and/or "no Mandos server found" better
 *** [#B] --dump option
-** TODO Remove old string_to_delta format				     :2:
+** TODO Remove old string_to_delta format				  :2:
 
 * TODO mandos-dispatch
   Listens for specified D-Bus signals and spawns shell commands with

=== modified file 'common.ent'
--- common.ent	2014-10-05 20:08:58 +0000
+++ common.ent	2014-07-17 03:24:57 +0000
@@ -1,3 +1,3 @@
 <?xml version="1.0" encoding="UTF-8"?>
 <!-- Edited by Makefile -->
-<!ENTITY version "1.6.9">
+<!ENTITY version "1.6.7">

=== modified file 'debian/changelog'
--- debian/changelog	2014-10-05 20:08:58 +0000
+++ debian/changelog	2014-07-17 03:24:57 +0000
@@ -1,25 +1,3 @@
-mandos (1.6.9-1) unstable; urgency=medium
-
-  * New upstream release.
-  * debian/control (Build-Depends): Fix "still uses GnutLS 2.x" by
-    changing from "libgnutls-dev" to "libgnutls28-dev | gnutls-dev"
-    (Closes: #762349)
-
- -- Teddy Hogeborn <teddy@recompile.se>  Sun, 05 Oct 2014 22:05:06 +0200
-
-mandos (1.6.8-1) unstable; urgency=medium
-
-  * New upstream release.
-  * debian/control (Source: mandos/Build-Depends-Indep): Since upstream
-    now requires Python 2.7, depend on exactly the python2.7 package and
-    all the Python 2.7 versions of the python modules.
-    (Package: mandos/Depends): - '' - but still depend on python (>=2.7)
-    and the generic versions of the Python modules; this is for mandos-ctl
-    and mandos-monitor, both of which are compatible with Python 3, and
-    use #!/usr/bin/python.
-
- -- Teddy Hogeborn <teddy@recompile.se>  Wed, 06 Aug 2014 22:55:24 +0200
-
 mandos (1.6.7-1) unstable; urgency=medium
 
   * New upstream release.

=== modified file 'debian/control'
--- debian/control	2014-10-08 21:03:05 +0000
+++ debian/control	2014-07-25 23:54:03 +0000
@@ -5,11 +5,11 @@
 Uploaders: Teddy Hogeborn <teddy@recompile.se>,
 	   Björn Påhlsson <belorn@recompile.se>
 Build-Depends: debhelper (>= 9), docbook-xml, docbook-xsl,
-	libavahi-core-dev, libgpgme11-dev, libgnutls28-dev
-	| gnutls-dev, xsltproc, pkg-config
+	libavahi-core-dev, libgpgme11-dev, libgnutls-dev, xsltproc,
+	pkg-config
 Build-Depends-Indep: systemd, python2.7, python2.7-gnutls,
 	python2.7-dbus, python2.7-avahi, python2.7-gobject
-Standards-Version: 3.9.6
+Standards-Version: 3.9.5
 Vcs-Bzr: http://ftp.recompile.se/pub/mandos/trunk
 Vcs-Browser: http://bzr.recompile.se/loggerhead/mandos/trunk/files
 Homepage: http://www.recompile.se/mandos

=== modified file 'initramfs-tools-hook'
--- initramfs-tools-hook	2015-06-28 16:35:27 +0000
+++ initramfs-tools-hook	2014-07-16 23:44:54 +0000
@@ -70,13 +70,11 @@
 CONFDIR="/conf/conf.d/mandos"
 MANDOSDIR="/lib/mandos"
 PLUGINDIR="${MANDOSDIR}/plugins.d"
-PLUGINHELPERDIR="${MANDOSDIR}/plugins-helpers"
 HOOKDIR="${MANDOSDIR}/network-hooks.d"
 
 # Make directories
 install --directory --mode=u=rwx,go=rx "${DESTDIR}${CONFDIR}" \
-	"${DESTDIR}${MANDOSDIR}" "${DESTDIR}${HOOKDIR}" \
-	"${DESTDIR}${PLUGINHELPERDIR}"
+	"${DESTDIR}${MANDOSDIR}" "${DESTDIR}${HOOKDIR}"
 install --owner=${mandos_user} --group=${mandos_group} --directory \
     --mode=u=rwx "${DESTDIR}${PLUGINDIR}"
 
@@ -100,21 +98,6 @@
     esac
 done
 
-# Copy the packaged plugin helpers
-for file in "$libdir"/mandos/plugin-helpers/*; do
-    base="`basename \"$file\"`"
-    # Is this plugin overridden?
-    if [ -e "/etc/mandos/plugin-helpers/$base" ]; then
-	continue
-    fi
-    case "$base" in
-	*~|.*|\#*\#|*.dpkg-old|*.dpkg-bak|*.dpkg-new|*.dpkg-divert)
-	    : ;;
-	"*") : ;;
-	*) copy_exec "$file" "${PLUGINHELPERDIR}" ;;
-    esac
-done
-
 # Copy any user-supplied plugins
 for file in /etc/mandos/plugins.d/*; do
     base="`basename \"$file\"`"
@@ -126,17 +109,6 @@
     esac
 done
 
-# Copy any user-supplied plugin helpers
-for file in /etc/mandos/plugin-helpers/*; do
-    base="`basename \"$file\"`"
-    case "$base" in
-	*~|.*|\#*\#|*.dpkg-old|*.dpkg-bak|*.dpkg-new|*.dpkg-divert)
-	    : ;;
-	"*") : ;;
-	*) copy_exec "$file" "${PLUGINHELPERDIR}" ;;
-    esac
-done
-
 # Get DEVICE from initramfs.conf and other files
 . /etc/initramfs-tools/initramfs.conf
 for conf in /etc/initramfs-tools/conf.d/*; do

=== modified file 'mandos'
--- mandos	2014-10-08 21:07:10 +0000
+++ mandos	2014-07-25 23:39:49 +0000
@@ -88,10 +88,7 @@
     except ImportError:
         SO_BINDTODEVICE = None
 
-if sys.version_info.major == 2:
-    str = unicode
-
-version = "1.6.9"
+version = "1.6.7"
 stored_state_file = "clients.pickle"
 
 logger = logging.getLogger()
@@ -107,8 +104,10 @@
         SIOCGIFINDEX = 0x8933  # From /usr/include/linux/sockios.h
         with contextlib.closing(socket.socket()) as s:
             ifreq = fcntl.ioctl(s, SIOCGIFINDEX,
-                                struct.pack(b"16s16x", interface))
-        interface_index = struct.unpack("I", ifreq[16:20])[0]
+                                struct.pack(str("16s16x"),
+                                            interface))
+        interface_index = struct.unpack(str("I"),
+                                        ifreq[16:20])[0]
         return interface_index
 
 
@@ -119,7 +118,7 @@
     syslogger = (logging.handlers.SysLogHandler
                  (facility =
                   logging.handlers.SysLogHandler.LOG_DAEMON,
-                  address = "/dev/log"))
+                  address = str("/dev/log")))
     syslogger.setFormatter(logging.Formatter
                            ('Mandos [%(process)d]: %(levelname)s:'
                             ' %(message)s'))
@@ -225,8 +224,9 @@
 class AvahiError(Exception):
     def __init__(self, value, *args, **kwargs):
         self.value = value
-        return super(AvahiError, self).__init__(value, *args,
-                                                **kwargs)
+        super(AvahiError, self).__init__(value, *args, **kwargs)
+    def __unicode__(self):
+        return unicode(repr(self.value))
 
 class AvahiServiceError(AvahiError):
     pass
@@ -275,31 +275,25 @@
         self.bus = bus
         self.entry_group_state_changed_match = None
     
-    def rename(self, remove=True):
+    def rename(self):
         """Derived from the Avahi example code"""
         if self.rename_count >= self.max_renames:
             logger.critical("No suitable Zeroconf service name found"
                             " after %i retries, exiting.",
                             self.rename_count)
             raise AvahiServiceError("Too many renames")
-        self.name = str(self.server
-                        .GetAlternativeServiceName(self.name))
-        self.rename_count += 1
+        self.name = unicode(self.server
+                            .GetAlternativeServiceName(self.name))
         logger.info("Changing Zeroconf service name to %r ...",
                     self.name)
-        if remove:
-            self.remove()
+        self.remove()
         try:
             self.add()
         except dbus.exceptions.DBusException as error:
-            if (error.get_dbus_name()
-                == "org.freedesktop.Avahi.CollisionError"):
-                logger.info("Local Zeroconf service name collision.")
-                return self.rename(remove=False)
-            else:
-                logger.critical("D-Bus Exception", exc_info=error)
-                self.cleanup()
-                os._exit(1)
+            logger.critical("D-Bus Exception", exc_info=error)
+            self.cleanup()
+            os._exit(1)
+        self.rename_count += 1
     
     def remove(self):
         """Derived from the Avahi example code"""
@@ -343,7 +337,7 @@
             self.rename()
         elif state == avahi.ENTRY_GROUP_FAILURE:
             logger.critical("Avahi: Error in group state changed %s",
-                            str(error))
+                            unicode(error))
             raise AvahiGroupError("State changed: {!s}"
                                   .format(error))
     
@@ -397,9 +391,9 @@
 
 
 class AvahiServiceToSyslog(AvahiService):
-    def rename(self, *args, **kwargs):
+    def rename(self):
         """Add the new name to the syslog messages"""
-        ret = AvahiService.rename(self, *args, **kwargs)
+        ret = AvahiService.rename(self)
         syslogger.setFormatter(logging.Formatter
                                ('Mandos ({}) [%(process)d]:'
                                 ' %(levelname)s: %(message)s'
@@ -694,7 +688,8 @@
         if self.checker is None:
             # Escape attributes for the shell
             escaped_attrs = { attr:
-                                  re.escape(str(getattr(self, attr)))
+                                  re.escape(unicode(getattr(self,
+                                                            attr)))
                               for attr in self.runtime_expansions }
             try:
                 command = self.checker_command % escaped_attrs
@@ -819,11 +814,11 @@
     """Decorator to annotate D-Bus methods, signals or properties
     Usage:
     
-    @dbus_annotations({"org.freedesktop.DBus.Deprecated": "true",
-                       "org.freedesktop.DBus.Property."
-                       "EmitsChangedSignal": "false"})
     @dbus_service_property("org.example.Interface", signature="b",
                            access="r")
+    @dbus_annotations({{"org.freedesktop.DBus.Deprecated": "true",
+                        "org.freedesktop.DBus.Property."
+                        "EmitsChangedSignal": "false"})
     def Property_dbus_property(self):
         return dbus.Boolean(False)
     """
@@ -836,7 +831,9 @@
 class DBusPropertyException(dbus.exceptions.DBusException):
     """A base class for D-Bus property-related exceptions
     """
-    pass
+    def __unicode__(self):
+        return unicode(str(self))
+
 
 class DBusPropertyAccessException(DBusPropertyException):
     """A property's access permissions disallows an operation.
@@ -952,14 +949,6 @@
                                            value.variant_level+1)
         return dbus.Dictionary(properties, signature="sv")
     
-    @dbus.service.signal(dbus.PROPERTIES_IFACE, signature="sa{sv}as")
-    def PropertiesChanged(self, interface_name, changed_properties,
-                          invalidated_properties):
-        """Standard D-Bus PropertiesChanged() signal, see D-Bus
-        standard.
-        """
-        pass
-    
     @dbus.service.method(dbus.INTROSPECTABLE_IFACE,
                          out_signature="s",
                          path_keyword='object_path',
@@ -1232,8 +1221,6 @@
     runtime_expansions = (Client.runtime_expansions
                           + ("dbus_object_path",))
     
-    _interface = "se.recompile.Mandos.Client"
-    
     # dbus.service.Object doesn't use super(), so we can't either.
     
     def __init__(self, bus = None, *args, **kwargs):
@@ -1241,7 +1228,7 @@
         Client.__init__(self, *args, **kwargs)
         # Only now, when this client is initialized, can it show up on
         # the D-Bus
-        client_object_name = str(self.name).translate(
+        client_object_name = unicode(self.name).translate(
             {ord("."): ord("_"),
              ord("-"): ord("_")})
         self.dbus_object_path = (dbus.ObjectPath
@@ -1251,8 +1238,7 @@
     
     def notifychangeproperty(transform_func,
                              dbus_name, type_func=lambda x: x,
-                             variant_level=1, invalidate_only=False,
-                             _interface=_interface):
+                             variant_level=1):
         """ Modify a variable so that it's a property which announces
         its changes to DBus.
         
@@ -1269,21 +1255,11 @@
                 if (not hasattr(self, attrname) or
                     type_func(getattr(self, attrname, None))
                     != type_func(value)):
-                    if invalidate_only:
-                        self.PropertiesChanged(_interface,
-                                               dbus.Dictionary(),
-                                               dbus.Array
-                                               ((dbus_name,)))
-                    else:
-                        dbus_value = transform_func(type_func(value),
-                                                    variant_level
-                                                    =variant_level)
-                        self.PropertyChanged(dbus.String(dbus_name),
-                                             dbus_value)
-                        self.PropertiesChanged(_interface,
-                                               dbus.Dictionary({
-                                    dbus.String(dbus_name):
-                                        dbus_value }), dbus.Array())
+                    dbus_value = transform_func(type_func(value),
+                                                variant_level
+                                                =variant_level)
+                    self.PropertyChanged(dbus.String(dbus_name),
+                                         dbus_value)
             setattr(self, attrname, value)
         
         return property(lambda self: getattr(self, attrname), setter)
@@ -1327,8 +1303,6 @@
                                     lambda td: td.total_seconds()
                                     * 1000)
     checker_command = notifychangeproperty(dbus.String, "Checker")
-    secret = notifychangeproperty(dbus.ByteArray, "Secret",
-                                  invalidate_only=True)
     
     del notifychangeproperty
     
@@ -1381,9 +1355,15 @@
         self.send_changedstate()
     
     ## D-Bus methods, signals & properties
+    _interface = "se.recompile.Mandos.Client"
     
     ## Interfaces
     
+    @dbus_interface_annotations(_interface)
+    def _foo(self):
+        return { "org.freedesktop.DBus.Property.EmitsChangedSignal":
+                     "false"}
+    
     ## Signals
     
     # CheckerCompleted - signal
@@ -1399,7 +1379,6 @@
         pass
     
     # PropertyChanged - signal
-    @dbus_annotations({"org.freedesktop.DBus.Deprecated": "true"})
     @dbus.service.signal(_interface, signature="sv")
     def PropertyChanged(self, property, value):
         "D-Bus signal"
@@ -1510,7 +1489,7 @@
     def Host_dbus_property(self, value=None):
         if value is None:       # get
             return dbus.String(self.host)
-        self.host = str(value)
+        self.host = unicode(value)
     
     # Created - property
     @dbus_service_property(_interface, signature="s", access="read")
@@ -1614,7 +1593,7 @@
     def Checker_dbus_property(self, value=None):
         if value is None:       # get
             return dbus.String(self.checker_command)
-        self.checker_command = str(value)
+        self.checker_command = unicode(value)
     
     # CheckerRunning - property
     @dbus_service_property(_interface, signature="b",
@@ -1636,7 +1615,7 @@
     @dbus_service_property(_interface, signature="ay",
                            access="write", byte_arrays=True)
     def Secret_dbus_property(self, value):
-        self.secret = bytes(value)
+        self.secret = str(value)
     
     del _interface
 
@@ -1676,7 +1655,7 @@
     def handle(self):
         with contextlib.closing(self.server.child_pipe) as child_pipe:
             logger.info("TCP connection from: %s",
-                        str(self.client_address))
+                        unicode(self.client_address))
             logger.debug("Pipe FD: %d",
                          self.server.child_pipe.fileno())
             
@@ -1981,8 +1960,7 @@
                 try:
                     self.socket.setsockopt(socket.SOL_SOCKET,
                                            SO_BINDTODEVICE,
-                                           (self.interface + "\0")
-                                           .encode("utf-8"))
+                                           str(self.interface + '\0'))
                 except socket.error as error:
                     if error.errno == errno.EPERM:
                         logger.error("No permission to bind to"
@@ -2248,7 +2226,7 @@
     timevalue = datetime.timedelta(0)
     for s in interval.split():
         try:
-            suffix = s[-1]
+            suffix = unicode(s[-1])
             value = int(s[:-1])
             if suffix == "d":
                 delta = datetime.timedelta(value)
@@ -2405,9 +2383,8 @@
     del options
     # Force all strings to be unicode
     for option in server_settings.keys():
-        if isinstance(server_settings[option], bytes):
-            server_settings[option] = (server_settings[option]
-                                       .decode("utf-8"))
+        if type(server_settings[option]) is str:
+            server_settings[option] = unicode(server_settings[option])
     # Force all boolean options to be boolean
     for option in ("debug", "use_dbus", "use_ipv6", "restore",
                    "foreground", "zeroconf"):
@@ -2556,8 +2533,7 @@
                                        protocol = protocol, bus = bus)
         if server_settings["interface"]:
             service.interface = (if_nametoindex
-                                 (server_settings["interface"]
-                                  .encode("utf-8")))
+                                 (str(server_settings["interface"])))
     
     global multiprocessing_manager
     multiprocessing_manager = multiprocessing.Manager()
@@ -2681,7 +2657,7 @@
             try:
                 with pidfile:
                     pid = os.getpid()
-                    pidfile.write("{}\n".format(pid).encode("utf-8"))
+                    pidfile.write(str(pid) + "\n".encode("utf-8"))
             except IOError:
                 logger.error("Could not write to file %r with PID %d",
                              pidfilename, pid)
@@ -2733,8 +2709,8 @@
             def GetAllClientsWithProperties(self):
                 "D-Bus method"
                 return dbus.Dictionary(
-                    { c.dbus_object_path: c.GetAll("")
-                      for c in tcp_server.clients.itervalues() },
+                    ((c.dbus_object_path, c.GetAll(""))
+                     for c in tcp_server.clients.itervalues()),
                     signature="oa{sv}")
             
             @dbus.service.method(_interface, in_signature="o")

=== modified file 'mandos-ctl'
--- mandos-ctl	2014-10-05 20:08:58 +0000
+++ mandos-ctl	2014-07-25 23:42:53 +0000
@@ -72,7 +72,7 @@
 server_path = "/"
 server_interface = domain + ".Mandos"
 client_interface = domain + ".Mandos.Client"
-version = "1.6.9"
+version = "1.6.7"
 
 def milliseconds_to_string(ms):
     td = datetime.timedelta(0, 0, 0, ms)

=== modified file 'mandos-keygen'
--- mandos-keygen	2014-10-05 20:08:58 +0000
+++ mandos-keygen	2014-08-06 20:45:04 +0000
@@ -21,7 +21,7 @@
 # Contact the authors at <mandos@recompile.se>.
 # 
 
-VERSION="1.6.9"
+VERSION="1.6.7"
 
 KEYDIR="/etc/keys/mandos"
 KEYTYPE=RSA

=== modified file 'mandos-monitor'
--- mandos-monitor	2014-10-05 20:08:58 +0000
+++ mandos-monitor	2014-07-25 23:42:53 +0000
@@ -60,7 +60,7 @@
 domain = 'se.recompile'
 server_interface = domain + '.Mandos'
 client_interface = domain + '.Mandos.Client'
-version = "1.6.9"
+version = "1.6.7"
 
 def isoformat_to_datetime(iso):
     "Parse an ISO 8601 date string to a datetime.datetime()"
@@ -87,9 +87,9 @@
         self.proxy = proxy_object # Mandos Client proxy object
         self.properties = dict() if properties is None else properties
         self.property_changed_match = (
-            self.proxy.connect_to_signal("PropertiesChanged",
-                                         self.properties_changed,
-                                         dbus.PROPERTIES_IFACE,
+            self.proxy.connect_to_signal("PropertyChanged",
+                                         self._property_changed,
+                                         client_interface,
                                          byte_arrays=True))
         
         if properties is None:
@@ -100,12 +100,16 @@
         
         super(MandosClientPropertyCache, self).__init__(**kwargs)
     
-    def properties_changed(self, interface, properties, invalidated):
-        """This is called whenever we get a PropertiesChanged signal
-        It updates the changed properties in the "properties" dict.
+    def _property_changed(self, property, value):
+        """Helper which takes positional arguments"""
+        return self.property_changed(property=property, value=value)
+    
+    def property_changed(self, property=None, value=None):
+        """This is called whenever we get a PropertyChanged signal
+        It updates the changed property in the "properties" dict.
         """
         # Update properties dict with new value
-        self.properties.update(properties)
+        self.properties[property] = value
     
     def delete(self):
         self.property_changed_match.remove()
@@ -373,15 +377,14 @@
         else:
             return key
     
-    def properties_changed(self, interface, properties, invalidated):
-        """Call self.update() if any properties changed.
+    def property_changed(self, property=None, **kwargs):
+        """Call self.update() if old value is not new value.
         This overrides the method from MandosClientPropertyCache"""
-        old_values = { key: self.properties.get(key)
-                       for key in properties.keys() }
-        super(MandosClientWidget, self).properties_changed(
-            interface, properties, invalidated)
-        if any(old_values[key] != self.properties.get(key)
-               for key in old_values):
+        property_name = str(property)
+        old_value = self.properties.get(property_name)
+        super(MandosClientWidget, self).property_changed(
+            property=property, **kwargs)
+        if self.properties.get(property_name) != old_value:
             self.update()
 
 

=== modified file 'mandos.lsm'
--- mandos.lsm	2014-10-05 20:08:58 +0000
+++ mandos.lsm	2014-07-17 03:24:57 +0000
@@ -1,7 +1,7 @@
 Begin4
 Title:		Mandos
-Version:	1.6.9
-Entered-date:	2014-10-05
+Version:	1.6.7
+Entered-date:	2014-07-17
 Description:	The Mandos system allows computers to have encrypted
 		root file systems and at the same time be capable of
 		remote and/or unattended reboots.
@@ -12,9 +12,9 @@
 Maintained-by:	teddy@recompile.se (Teddy Hogeborn),
 		belorn@recompile.se (Björn Påhlsson)
 Primary-site:	http://www.recompile.se/mandos
-		161K mandos_1.6.9.orig.tar.gz
+		161K mandos_1.6.7.orig.tar.gz
 Alternate-site:	ftp://ftp.recompile.se/pub/mandos
-		161K mandos_1.6.9.orig.tar.gz
+		161K mandos_1.6.7.orig.tar.gz
 Platforms:	Requires GCC, GNU libC, Avahi, GnuPG, Python 2.6, and
 		various other libraries.  While made for Debian
 		GNU/Linux, it is probably portable to other

=== modified file 'mandos.service'
--- mandos.service	2014-10-05 19:39:25 +0000
+++ mandos.service	2014-08-06 20:33:26 +0000
@@ -1,6 +1,5 @@
 [Unit]
 Description=Server of encrypted passwords to Mandos clients
-Documentation=man:intro(8mandos) man:mandos(8)
 
 [Service]
 Type=simple

=== removed directory 'plugin-helpers'
=== modified file 'plugin-runner.c'
--- plugin-runner.c	2015-06-28 16:35:27 +0000
+++ plugin-runner.c	2014-07-16 01:41:23 +0000
@@ -76,7 +76,6 @@
 #define BUFFER_SIZE 256
 
 #define PDIR "/lib/mandos/plugins.d"
-#define PHDIR "/lib/mandos/plugin-helpers"
 #define AFILE "/conf/conf.d/mandos/plugin-runner.conf"
 
 const char *argp_program_version = "plugin-runner " VERSION;
@@ -348,7 +347,6 @@
 
 int main(int argc, char *argv[]){
   char *plugindir = NULL;
-  char *pluginhelperdir = NULL;
   char *argfile = NULL;
   FILE *conffp;
   struct dirent **direntries = NULL;
@@ -416,10 +414,6 @@
       .doc = "Group ID the plugins will run as", .group = 3 },
     { .name = "debug", .key = 132,
       .doc = "Debug mode", .group = 4 },
-    { .name = "plugin-helper-dir", .key = 133,
-      .arg = "DIRECTORY",
-      .doc = "Specify a different plugin helper directory",
-      .group = 2 },
     /*
      * These reproduce what we would get without ARGP_NO_HELP
      */
@@ -551,13 +545,6 @@
     case 132:			/* --debug */
       debug = true;
       break;
-    case 133:			/* --plugin-helper-dir */
-      free(pluginhelperdir);
-      pluginhelperdir = strdup(arg);
-      if(pluginhelperdir != NULL){
-	errno = 0;
-      }
-      break;
       /*
        * These reproduce what we would get without ARGP_NO_HELP
        */
@@ -614,7 +601,6 @@
     case 130:			/* --userid */
     case 131:			/* --groupid */
     case 132:			/* --debug */
-    case 133:			/* --plugin-helper-dir */
     case '?':			/* --help */
     case -3:			/* --usage */
     case 'V':			/* --version */
@@ -775,24 +761,6 @@
     goto fallback;
   }
   
-  {
-    char *pluginhelperenv;
-    bool bret = true;
-    ret = asprintf(&pluginhelperenv, "MANDOSPLUGINHELPERDIR=%s",
-		   pluginhelperdir != NULL ? pluginhelperdir : PHDIR);
-    if(ret != -1){
-      bret = add_environment(getplugin(NULL), pluginhelperenv, true);
-    }
-    if(ret == -1 or not bret){
-      error(0, errno, "Failed to set MANDOSPLUGINHELPERDIR"
-	    " environment variable to \"%s\" for all plugins\n",
-	    pluginhelperdir != NULL ? pluginhelperdir : PHDIR);
-    }
-    if(ret != -1){
-      free(pluginhelperenv);
-    }
-  }
-  
   if(debug){
     for(plugin *p = plugin_list; p != NULL; p=p->next){
       fprintf(stderr, "Plugin: %s has %d arguments\n",
@@ -1368,7 +1336,6 @@
   free_plugin_list();
   
   free(plugindir);
-  free(pluginhelperdir);
   free(argfile);
   
   return exitstatus;

=== modified file 'plugin-runner.xml'
--- plugin-runner.xml	2015-06-28 16:35:27 +0000
+++ plugin-runner.xml	2011-12-31 23:05:34 +0000
@@ -2,7 +2,7 @@
 <!DOCTYPE refentry PUBLIC "-//OASIS//DTD DocBook XML V4.5//EN"
 	"http://www.oasis-open.org/docbook/xml/4.5/docbookx.dtd" [
 <!ENTITY COMMANDNAME "plugin-runner">
-<!ENTITY TIMESTAMP "2015-06-28">
+<!ENTITY TIMESTAMP "2012-01-01">
 <!ENTITY % common SYSTEM "common.ent">
 %common;
 ]>
@@ -114,9 +114,6 @@
       <arg><option>--plugin-dir=<replaceable
       >DIRECTORY</replaceable></option></arg>
       <sbr/>
-      <arg><option>--plugin-helper-dir=<replaceable
-      >DIRECTORY</replaceable></option></arg>
-      <sbr/>
       <arg><option>--config-file=<replaceable
       >FILE</replaceable></option></arg>
       <sbr/>
@@ -323,21 +320,6 @@
       </varlistentry>
       
       <varlistentry>
-	<term><option>--plugin-helper-dir
-	<replaceable>DIRECTORY</replaceable></option></term>
-	<listitem>
-	  <para>
-	    Specify a different plugin helper directory.  The default
-	    is <filename>/lib/mandos/plugin-helpers</filename>, which
-	    will exist in the initial <acronym>RAM</acronym> disk
-	    environment.  (This will simply be passed to all plugins
-	    via the <envar>MANDOSPLUGINHELPERDIR</envar> environment
-	    variable.  See <xref linkend="writing_plugins"/>)
-	  </para>
-	</listitem>
-      </varlistentry>
-      
-      <varlistentry>
 	<term><option>--config-file
 	<replaceable>FILE</replaceable></option></term>
 	<listitem>
@@ -444,11 +426,7 @@
       <para>
 	The plugin will run in the initial RAM disk environment, so
 	care must be taken not to depend on any files or running
-	services not available there.  Any helper executables required
-	by the plugin (which are not in the <envar>PATH</envar>) can
-	be placed in the plugin helper directory, the name of which
-	will be made available to the plugin via the
-	<envar>MANDOSPLUGINHELPERDIR</envar> environment variable.
+	services not available there.
       </para>
       <para>
 	The plugin must exit cleanly and free all allocated resources
@@ -497,9 +475,7 @@
       only passes on its environment to all the plugins.  The
       environment passed to plugins can be modified using the
       <option>--global-env</option> and <option>--env-for</option>
-      options.  Also, the <option>--plugin-helper-dir</option> option
-      will affect the environment variable
-      <envar>MANDOSPLUGINHELPERDIR</envar> for the plugins.
+      options.
     </para>
   </refsect1>
   

=== modified file 'plugins.d/askpass-fifo.c'
--- plugins.d/askpass-fifo.c	2014-08-09 23:37:07 +0000
+++ plugins.d/askpass-fifo.c	2014-03-29 02:38:15 +0000
@@ -23,7 +23,7 @@
  */
 
 #define _GNU_SOURCE		/* TEMP_FAILURE_RETRY() */
-#include <sys/types.h>		/* uid_t, gid_t, ssize_t */
+#include <sys/types.h>		/* ssize_t */
 #include <sys/stat.h>		/* mkfifo(), S_IRUSR, S_IWUSR */
 #include <iso646.h>		/* and */
 #include <errno.h>		/* errno, EACCES, ENOTDIR, ELOOP,
@@ -44,8 +44,6 @@
 #include <string.h> 		/* strerror() */
 #include <stdarg.h>		/* va_list, va_start(), ... */
 
-uid_t uid = 65534;
-gid_t gid = 65534;
 
 /* Function to use when printing errors */
 __attribute__((format (gnu_printf, 3, 4)))
@@ -76,9 +74,6 @@
   int ret = 0;
   ssize_t sret;
   
-  uid = getuid();
-  gid = getgid();
-  
   /* Create FIFO */
   const char passfifo[] = "/lib/cryptsetup/passfifo";
   ret = mkfifo(passfifo, S_IRUSR | S_IWUSR);
@@ -124,16 +119,6 @@
     }
   }
   
-  /* Lower group privileges  */
-  if(setgid(gid) == -1){
-    error_plus(0, errno, "setgid");
-  }
-  
-  /* Lower user privileges */
-  if(setuid(uid) == -1){
-    error_plus(0, errno, "setuid");
-  }
-  
   /* Read from FIFO */
   char *buf = NULL;
   size_t buf_len = 0;

=== modified file 'plugins.d/mandos-client.c'
--- plugins.d/mandos-client.c	2014-08-20 21:46:38 +0000
+++ plugins.d/mandos-client.c	2014-07-15 23:52:00 +0000
@@ -1650,11 +1650,6 @@
 	_exit(EXIT_FAILURE);
       }
     } else {
-      if(hook_pid == -1){
-	perror_plus("fork");
-	free(direntry);
-	continue;
-      }
       int status;
       if(TEMP_FAILURE_RETRY(waitpid(hook_pid, &status, 0)) == -1){
 	perror_plus("waitpid");

